<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { ref, computed, onMounted } from 'vue';
import { useRouter } from 'vue-router';
import { storeToRefs } from 'pinia';
import Button from '@/components/general/Button.vue';
import Tab from '@/components/general/Tab.vue';
//import Tooltip from '@/components/general/Tooltip.vue';
import ListItem from '@/components/chat/NavigationListItem.vue';
import TokenUsage from '@/components/chat/LayoutTokenUsage.vue';


import { useChatStore } from '@/stores/chat';
import type { Chat } from "@/types/chat";


const chatStore = useChatStore();
const { tab, chats, state, activeChatUuid } = storeToRefs(chatStore);
const router = useRouter();

const handleTab = (value: string) => {
    tab.value = value;
};

onMounted(async () => {
    activeChatUuid.value = router.currentRoute.value.params.uuid as string;
    setTimeout(() => {
        const element = chats.value.find((chat: Chat) => chat.uuid === activeChatUuid.value);
        if (element)
            tab.value = element.type;
    }, 500);
});


const handleOpenChat = (uuid: string) => {
    activeChatUuid.value = uuid;
    router.push({ path: '/overview/chat/' + uuid });
    const selectedChat: any = chats.value.find((chat: Chat) => chat.uuid === uuid);
    if (selectedChat) {
        chatStore.updateChatTitle(selectedChat.name);
    }
};

const computedChats = computed(() => {
    if (tab.value === 'chat') return chats.value.filter((chat: Chat) => chat.type === 'chat').map((chat: Chat) => { return { name: chat.name, uuid: chat.uuid, avatar: chat.avatar, icon: 'chat-1', type: chat.type, maxDate: chat.max_date, validUntil: chat.valid_until } });
    else if (tab.value === 'image') return chats.value.filter((chat: Chat) => chat.type === 'image').map((chat: Chat) => { return { name: chat.name, uuid: chat.uuid, avatar: chat.avatar, icon: 'image', type: chat.type, maxDate: chat.max_date, validUntil: chat.valid_until } });
    else return chats.value.filter((chat: Chat) => chat.type === 'person').map((chat: Chat) => { return { name: chat.name, uuid: chat.uuid, avatar: chat.avatar, icon: 'user', type: chat.type, maxDate: chat.max_date, validUntil: chat.valid_until } });
});

const handleAdd = () => {
    if (tab.value === 'chat')
        handleShowCreateChatModal();
    else if (tab.value === 'person')
        handleShowCreatePersonModal();
    else if (tab.value === 'image')
        handleShowCreateImageModal();
};

const handleShowCreateChatModal = () => {
    state.value = "CHAT_CREATE";

};

const handleShowCreatePersonModal = () => {
    state.value = 'PERSON_CREATE';
};

const handleShowCreateImageModal = () => {
    state.value = 'IMAGE_CREATE';
};

const handleGoToPersons = () => {
    activeChatUuid.value = "";
    router.push({ name: 'chat-persons' });
};

const handleGoToPanes = () => {
    router.push({ name: 'overview-account' });
};

const checkIfExpiring = (date: string) => {
    const futureCheck = new Date(date);
    futureCheck.setDate(futureCheck.getDate() + 6 * 7);
    const delta = Math.floor((+futureCheck - +new Date()) / (1000 * 60 * 60 * 24))
    return delta > -1 && delta < 7 ? delta : undefined;
};

const checkIfShared = (date: string) => {
    if(date){
        const localDate = new Date(date);
        if (localDate > new Date())
            return localDate.toLocaleString();
    }
    return undefined;
};

</script>
<template>
    <div class="flex flex-col gap-2 p-2 h-full">
        <div class="mb-1">
            <Button variant="accent2" size="small" @click="handleGoToPanes"><i class="ri-home-2-line text-[16px]"></i>
                <span class="mt-px ml-2">{{ $t('ai.overview.backToPanes.label')
                    }}</span>
            </Button>
        </div>
        <div class="uppercase text-center text-gray-500 select-none"><i
                class="ri-robot-2-line text-[16px] -mt-px mr-2"></i><span class="mt-px">{{ $t('dashboardPage.ai.label')
                }}</span></div>
        <div class="flex flex-row w-full justify-stretch">
            <Tab :active="tab === 'chat'" @click="() => handleTab('chat')">
                <div class="w-full">
                    <Tooltip :tooltip="$t('ai.chat.title')"><i class="ri-chat-1-line"></i></Tooltip>
                </div>
            </Tab>
            <Tab :active="tab === 'image'" @click="() => handleTab('image')">
                <div class="w-full">
                    <Tooltip :tooltip="$t('ai.image.title')"><i class="ri-image-line"></i></Tooltip>
                </div>
            </Tab>
            <Tab :active="tab === 'person'" @click="() => handleTab('person')">
                <div class="w-full">
                    <Tooltip :tooltip="$t('ai.person.title')"><i class="ri-group-3-line"></i></Tooltip>
                </div>
            </Tab>
        </div>
        <div class="flex flex-row justify-stretch w-full gap-2">
            <div class="w-full">
                <Tooltip
                    :tooltip="tab !== 'person' ? tab !== 'image' ? $t('ai.chat.create.tooltip') : $t('ai.image.create.tooltip') : $t('ai.person.create.tooltip')">
                    <Button variant="accent1" size="small" @click="handleAdd"><i class="ri-add-line ri-2x"></i></Button>
                </Tooltip>
            </div>
            <div class="w-full" v-if="tab === 'person'">
                <Tooltip :tooltip="$t('ai.person.overview.tooltip')">
                    <Button variant="accent2" size="small" @click="handleGoToPersons"><i
                            class="ri-group-3-line ri-2x"></i></Button>
                </Tooltip>
            </div>
        </div>
        <div class="min-h-[calc(100dvh-364px)] max-h-[calc(100dvh-364px)] overflow-y-auto">
            <div class="max-w-full flex flex-col gap-1">
                <ListItem :uuid="item.uuid" :label="item.name" :icon="item.icon" :avatar="item.avatar"
                    v-for="item in computedChats" @click="handleOpenChat" :isActive="activeChatUuid === item.uuid"
                    :type="item.type" :expireDays="checkIfExpiring(item.maxDate)"
                    :sharedUntil="item.validUntil ? checkIfShared(item.validUntil) : undefined">
                </ListItem>
            </div>
        </div>
        <TokenUsage />
    </div>

</template>